

#include <Wire.h>
#include <SoftwareSerial.h>

bool bEstop = true;
bool bMist = false;
bool bJog = false;
bool bMachine = false;
char XReading[9];  // 0000.000\0 pos
char YReading[9];
char ZReading[9];
void zeroX() { 
  for(int x = 0; x < 9; x++) XReading[x] = 0;
}
void zeroY() { 
  for(int x = 0; x < 9; x++) YReading[x] = 0;
}
void zeroZ() { 
  for(int x = 0; x < 9; x++) ZReading[x] = 0;
}
// predef
void sendCommand(char); 

// the setup routine runs once when you press reset:
void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);

}



// the loop routine runs over and over again forever:
void loop() {
  int x;
  //Input DRO funktionen fungerar

  if(Serial.available()){
    char Sinput = Serial.read();
     switch(Sinput)
     {
     case 'X':
     while(Serial.available() < 8)
     delay(10);
     for(x = 0; x < 8; x++)
     XReading[x] = Serial.read();
     Serial.println(XReading);
     zeroX();
     break;                    
     
     case 'Y':
     while(Serial.available() < 8)
     delay(10);
     for(x = 0; x < 8; x++)
     YReading[x] = Serial.read();
     Serial.println(YReading);
     zeroY();
     break;                    
     
     case 'Z':
     while(Serial.available() < 8)
     delay(10);
     for(x = 0; x < 8; x++)
     ZReading[x] = Serial.read();
     Serial.println(ZReading);
     zeroZ();
     break;
     default:
     break;
     }
    sendCommand(Sinput); 

  }

}



void sendCommand(char keyPress){
  
  String Mess = "You sent: ";
  switch(keyPress)
  {
  case 'D': // ESTOP
    
    if(bEstop)
    {
      //Serial.println(Mess + keyPress);
      // send estop reset
      Serial.write('e');
      bMachine = false;  
      bEstop = false; 
    }
    else
    {
      //Serial.println(Mess + keyPress);
      // send estop activate & switch machine off too
      Serial.write('E');                        
      bEstop = true; 
      sendCommand('P');  // M OFF
      sendCommand('Q');  // blank MDI display
      sendCommand('R');  // JOG OFF
      sendCommand('S');  // MIST OFF
    }
    break;

  case '9': // MACHINE ON / OFF
    if(bMachine)
    {
      // send machine off
      Serial.write('m');
      sendCommand('P');  // M OFF
      sendCommand('Q');  // blank MDI display
      sendCommand('R');  // JOG OFF  
      sendCommand('S');  // MIST OFF
    }
    else
    {
      // send machine on unless in estop
      if(!bEstop)
      {
        Serial.write('M');
        bMachine = true;  
      }
    }
    break;  

  case '7':   // HOME ALL
    if(!bEstop)
    {                        
      bMist = false; 
      Serial.write('H');
    }
    break;                    

  case '*':   // MDI 1
    if(!bEstop && bMachine)
    {
      Serial.write('1');
    }
    break;

  case '0':   // MDI 2
    if(!bEstop && bMachine)
    {
      Serial.write('2');
    }
    break;

  case '#':   // MDI 3
    if(!bEstop && bMachine)
    {
      Serial.write('3');
    }
    break;

    //###########################################
    // re-entrant cases to carry out blanking etc
    // to save duplicating code
    //###########################################

  case 'P':    // machine off
    bMachine = false; 
    break;

  case 'Q':  // MDI off for use by estop etc                                 
    break;

  case 'R':   // JOG OFF
    bJog = false;                 
    break;

  case 'S':   // MIST OFF
    bMist = false;  
    break;                            

    //###########################################

  case '8':   // Mist On / OFF
    if(bMist)
    {
      // send mist off
      Serial.write('c');
      sendCommand('S');
    }
    else
    {
      // send mist activate
      if(!bEstop && bMachine)
      {
        Serial.write('C'); 
        bMist = true;                          
      }
    }
    break;

  case 'A':   // X
    Serial.write('X'); 
    break;                  

  case 'B':   // Y
    Serial.write('Y');
    break;                  

  case 'C':   // Z
    Serial.write('Z'); 
    break;  

  case '2': // JOG ON /OFF
    if(bJog)
    {
      // send jog off
      Serial.write('j');
      sendCommand('R');  // JOG OFF
    }
    else
    {
      // send jog activate
      if(!bEstop && bMachine)
      {
        Serial.write('J');                        
        bJog = true;  
      }
    }
    break;                    

  case '4': // 100mm/min
    Serial.write('4');
    break;

  case '5': // 10mm/min
    Serial.write('5');
    break;

  case '6': // 1mm/min
    Serial.write('6');
    break;                        

  case '1': // Jog minus <
    if(bJog)
      Serial.write('<');
    break;                

  case '3': // Jog plus >
    if(bJog)
      Serial.write('>');
    break;                

  default:
    break;
  }

}
